PluginCollection (Gradle API 4.3.1)
Date: 2017-11-08

org.gradle.api.plugins

## Interface PluginCollection<T extends Plugin>

- Type Parameters:
    `T` - The type of plugins which this collection contains.
  All Superinterfaces:
    Collection<T>, DomainObjectCollection<T>, DomainObjectSet<T>, Iterable<T>, Set<T>
  All Known Subinterfaces:
    PluginContainer

      public interface PluginCollection<T extends Plugin>
      extends DomainObjectSet<T>

  A `PluginCollection` represents a collection of `Plugin` instances.

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `PluginCollection<T>` | `matching(Closure closure)` Returns a collection which contains the objects in this collection which meet the given closure specification.
    `PluginCollection<T>` | `matching(Spec<? super T> spec)` Returns a collection which contains the objects in this collection which meet the given specification.
    `Action<? super T>` | `whenPluginAdded(Action<? super T> action)` Adds an `Action` to be executed when a plugin is added to this collection.
    `void` | `whenPluginAdded(Closure closure)` Adds a closure to be called when a plugin is added to this collection.
    `<S extends T> PluginCollection<S>` | `withType(Class<S> type)` Returns a collection containing the objects in this collection of the given type.

    - ### Methods inherited from interface org.gradle.api.DomainObjectSet

      `findAll`

    - ### Methods inherited from interface org.gradle.api.DomainObjectCollection

      `all, all, whenObjectAdded, whenObjectAdded, whenObjectRemoved, whenObjectRemoved, withType, withType`

    - ### Methods inherited from interface java.util.Set

      `add, addAll, clear, contains, containsAll, equals, hashCode, isEmpty, iterator, remove, removeAll, retainAll, size, toArray, toArray`

- - ### Method Detail

    - #### matching

          PluginCollection<T> matching(Spec<? super T> spec)

      Returns a collection which contains the objects in this collection which meet the given specification. The returned collection is live, so that when matching objects are added to this collection, they are also visible in the filtered collection.
      Specified by:
        `matching` in interface `DomainObjectCollection<T extends Plugin>`
      Specified by:
        `matching` in interface `DomainObjectSet<T extends Plugin>`
      Parameters:
        `spec` - The specification to use.
      Returns:
        The collection of matching objects. Returns an empty collection if there are no such objects in this collection.

    - #### matching

          PluginCollection<T> matching(Closure closure)

      Returns a collection which contains the objects in this collection which meet the given closure specification. The returned collection is live, so that when matching objects are added to this collection, they are also visible in the filtered collection.
      Specified by:
        `matching` in interface `DomainObjectCollection<T extends Plugin>`
      Specified by:
        `matching` in interface `DomainObjectSet<T extends Plugin>`
      Parameters:
        `closure` - The specification to use. The closure gets a collection element as an argument.
      Returns:
        The collection of matching objects. Returns an empty collection if there are no such objects in this collection.

    - #### withType

          <S extends T> PluginCollection<S> withType(Class<S> type)

      Returns a collection containing the objects in this collection of the given type. The returned collection is live, so that when matching objects are later added to this collection, they are also visible in the filtered collection.
      Specified by:
        `withType` in interface `DomainObjectCollection<T extends Plugin>`
      Specified by:
        `withType` in interface `DomainObjectSet<T extends Plugin>`
      Parameters:
        `type` - The type of objects to find.
      Returns:
        The matching objects. Returns an empty collection if there are no such objects in this collection.

    - #### whenPluginAdded

          Action<? super T> whenPluginAdded(Action<? super T> action)

      Adds an `Action` to be executed when a plugin is added to this collection.
      Parameters:
        `action` - The action to be executed
      Returns:
        the supplied action

    - #### whenPluginAdded

          void whenPluginAdded(Closure closure)

      Adds a closure to be called when a plugin is added to this collection. The plugin is passed to the closure as the parameter.
      Parameters:
        `closure` - The closure to be called